<template>
  <div class="p-4 pb-20 min-h-[calc(50vh-72px)]">
    <div class="flex flex-col item-start pt-4 pb-10">
      <div>
        <span
          class="text-xs flex items-center text-[var(--text2)] font-semibold uppercase mb-4 cursor-pointer"
          @click="() => [dialogVisible = false, $router.push('/promotion')]"
        >
          <font-awesome-icon icon="long-arrow-left" class="text-2xl mr-2" />
          <span>{{ $t("back") }}</span>
        </span>
        <span class="status--tag">{{ promotion.PromoCode }}</span>
      </div>
      <h2 class="promotion-detail__title">{{ promotion.Title }}</h2>
      <div class="w-full mt-4 mb-10">
        <img
          v-lazy="promotion.ImagePathForDisplay"
          class="rounded-2xl"
          alt="promotion image"
        />
      </div>
      <div class="mb-5 pb-px">
        <template v-if="promotion.PromotionTypeId === 10">
          <el-button
            v-if="validateLuckyWheelbutton(promotion)"
            class="btn-default"
            @click="onClickSpinNow"
            :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
            >{{ $t("Spin Now") }}</el-button
          >
        </template>
        <template v-else>
          <el-button
            v-if="auth"
            class="btn-default"
            @click="onApplyPromotion(promotion)"
            :id="`mobile_${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
            >{{ $t("apply") }}</el-button
          >
        </template>
      </div>
      <div class="flex flex-col">
        <div class="promotion-info__stat">
          <div>
            <span>{{ $t("promotion_code") }}</span>
            <span class="promotion-stat__value">{{ promotion.PromoCode }}</span>
          </div>
          <div>
            <div
              v-if="promotion.Remark !== null && promotion.Remark.trim().length"
              class="promotion-stat__item"
            >
              <span>{{ $t("remark") }}</span>
              <span class="promotion-stat__value">{{ promotion.Remark }}</span>
            </div>
            <div class="promotion-stat__item">
              <span>{{ $t("start_date") }}</span>
              <span class="promotion-stat__value">{{
                promotion.StartDateForDisplay
              }}</span>
            </div>
            <div class="promotion-stat__item">
              <span>{{ $t("end_date") }}</span>
              <span class="promotion-stat__value">{{
                promotion.EndDateForDisplay
              }}</span>
            </div>
            <div
              v-if="
                promotion.Content !== null && promotion.Content.trim().length
              "
              class="promotion-stat__item"
            >
              <span>{{ $t("content") }}</span>
              <span
                class="promotion-stat__value"
                v-html="promotion.Content"
              ></span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { inject } from "vue";
import { IPromotion, Promotion } from "@/models/promotion/promotion";
import { ID } from "~~/utils/constants";
defineProps({
  promotion: {
    type: Object as PropType<Promotion>,
    required: true,
  },
  auth: {
    type: Boolean,
    default: false,
  },
  validateLuckyWheelbutton: {
    type: Boolean,
    required: true,
  },
  onClickSpinNow: {
    type: Function,
    required: true,
  },
});
const dialogVisible = inject("dialogVisible");
const onApplyPromotion = inject("onApplyPromotion") as (
  promotion: IPromotion,
) => Promise<void>;
</script>

<style scoped>
.btn-default,
.btn-primary {
  height: 40px;
  cursor: pointer;
}
.promotion-detail__title {
  display: flex;
  align-items: center;
  margin-bottom: 0;
  font-size: 24px;
  color: var(--title-font-color);
  margin-top: 4px;
  font-weight: 600;
  margin-top: 0.75rem;
}
.btn-default /deep/ span{
  pointer-events: none;
}
</style>
